#include "CircBuff.h"
#include <mem.h>

TcircularBuffer::TcircularBuffer(unsigned int size)
	{buffer=new char[size];
	wp=rp=buffer;
	e_of_buf=buffer+size-1;
	buffer_size=size;
	data_waiting=0;
	}

TcircularBuffer::~TcircularBuffer()
	{delete[]buffer;
	}

unsigned int TcircularBuffer::add(char data)
	{if(data_waiting==buffer_size)
		bump(&rp);		// buffer is full, so over-write start of buffer
	else
		data_waiting++;
	*wp=data;
	bump(&wp);
	return data_waiting;
	}

unsigned int TcircularBuffer::read(char *dest,unsigned int size,int discard)
	{size=(size<data_waiting)?size:data_waiting;
	if(size)
		{register int i=size;
		register char *p=rp;
		while(i--)
			{*(dest++)=*p;
			bump(&p);
			}
		if(discard)
			{rp=p;
			data_waiting-=size;
			}
		}
	return size;
	}

// DO NOT call this from an ISR, it uses new and so is not re-enterant!!
char *TcircularBuffer::linearize()
	{if(rp==buffer)
		return rp;
	if(data_waiting)
		{char *temp=new char[data_waiting];
		if(wp<rp)
			{int size=(e_of_buf-rp)+1;
			memcpy(temp,rp,size);
			memcpy(temp+size,buffer,data_waiting-size);
			}
		else
			memcpy(temp,rp,data_waiting);
		memset((void*)buffer,0,buffer_size); // tidy: not necessary if calling
		memcpy(buffer,temp,data_waiting);    // functions behave themselves!
		delete[]temp;
		}
	rp=buffer;
	wp=rp+data_waiting;
	return rp;
	}

unsigned int TcircularBuffer::discard(unsigned int size)
	{size=(size<data_waiting)?size:data_waiting;
	if((rp+size)>e_of_buf)    //  copes with discard that wraps around
		rp=buffer+(size-(e_of_buf-rp));
	else
		rp+=size;
	return data_waiting-=size;
	}

void TcircularBuffer::clearAll()
	{rp=wp=buffer;
	data_waiting=0;
	memset((void*)buffer,0,buffer_size);
	}
