#ifndef _RS232_A_H
#define _RS232_A_H

#include "serial.h"
#include "circbuff.h"

void interrupt com_int(...);

class RS232
	{friend void interrupt com_int(...);
	TcircularBuffer *Rx_buf;
	TcircularBuffer *Monitor_buf;
	int selectedPort;
	int portbase;
	volatile int echo_expected;
	void interrupt(*oldvect)(...);
	int oldIMR;
	void setvects();
	void resvects();
	int out(char data);
	void comm_on();
	void comm_off();
	void intsOn();
	void intsOff();
	int deActivate();
	int SetPort(int port);
	int SetSpeed(int speed);
	int SetPar_bits_stop(int Parity,int Bits,int StopBit);
	int isActive;
	int InterruptsOn;
	int echo_mode;
	int Txcr_to_Rxcrnl;
public:
	enum port{com1=1,com2};
	enum parity{none=0,odd=0x08,even=0x18};
	enum {good=0,cts_timeout,rts_timeout,null_port,zero_speed,zero_pbase,
				  bad_bitlen,bad_stopbits,bad_parity}error;
	RS232(int port,int speed,int parity,int bits,int stop_bit,TcircularBuffer *Rx,TcircularBuffer *Mon=0);
	~RS232();
	virtual void handleComInt();  // change in descendants, if required.
	int Activate();
	int out(char *string);
	int out(TcircularBuffer *buf);
	void setEchoOn(){echo_mode=1;echo_expected=0;}
	void clearEchoOn(){echo_mode=0;echo_expected=0;}
	void set_cr_translate(){Txcr_to_Rxcrnl=1;}
	void clear_cr_translate(){Txcr_to_Rxcrnl=0;}
	};

#ifdef _RS232_A_CPP
	extern RS232 *TheRS232;
#endif
#endif  // _RS232_A_H